Compare commits

..

2 Commits

Author SHA1 Message Date
AJ ONeal
53aaef50bd f: neovim 2023-11-03 00:03:03 +00:00
AJ ONeal
80caf75d9a WIP: feat: add neovim 2023-11-03 00:03:03 +00:00
32 changed files with 485 additions and 1350 deletions

View File

@@ -14,18 +14,9 @@ __install_webi() {
#WEBI_HOST=https://webinstall.dev
export WEBI_HOST
my_libc=''
if ldd /bin/ls 2> /dev/null | grep -q 'musl' 2> /dev/null; then
my_libc='musl'
elif uname -o | grep -q 'GNU' || uname -s | grep -q 'Linux'; then
my_libc='gnu'
else
my_libc='libc'
fi
if test -z "$WEBI_WELCOME"; then
echo ""
printf "Thanks for using webi to install '\e[32m%s\e[0m' on '\e[33m%s (%s) %s\e[0m'.\n" "${WEBI_PKG:-"Unknown Package"}" "$(uname -s)" "${my_libc:-"Unknown Libc"}" "$(uname -m)"
printf "Thanks for using webi to install '\e[32m%s\e[0m' on '\e[33m%s/%s\e[0m'.\n" "${WEBI_PKG-}" "$(uname -s)/$(uname -r)" "$(uname -m)"
echo "Have a problem? Experience a bug? Please let us know:"
printf " \e[2m\e[36mhttps://github.com/webinstall/webi-installers/issues\e[0m\n"
echo ""
@@ -113,11 +104,7 @@ __webi_main() {
my_libc=''
if ldd /bin/ls 2> /dev/null | grep -q 'musl' 2> /dev/null; then
my_libc='musl'
elif uname -o | grep -q 'GNU' || uname -s | grep -q 'Linux'; then
my_libc='gnu'
else
my_libc='libc'
my_libc=' musl-native'
fi
export WEBI_HOST="\${WEBI_HOST:-https://webinstall.dev}"

View File

@@ -0,0 +1,19 @@
#!/bin/sh
set -e
set -u
# For installing from the extracted package tmp directory
pkg_install() {
(
cd "$WEBI_TMP"
if command -v rsync 2> /dev/null | grep -q rsync; then
rsync -Krl ./xmpl*/ "$pkg_src/" 2> /dev/null
else
cp -Hr ./xmpl*/* "$pkg_src/" 2> /dev/null
cp -Hr ./xmpl*/.* "$pkg_src/" 2> /dev/null
fi
rm -rf ./xmpl*
)
}

View File

@@ -13,7 +13,6 @@ var osMap = {
var maps = {
oses: {},
arches: {},
libcs: {},
formats: {},
};
@@ -66,18 +65,11 @@ arches.forEach(function (name) {
maps.arches[name] = true;
});
var libcs = ['none', 'musl', 'gnu', 'msvc', 'libc'];
libcs.forEach(function (name) {
maps.libcs[name] = true;
});
function normalize(all) {
/* jshint maxcomplexity:50 */
/* jshint maxdepth:10 */
/* jshint maxcomplexity:26 */
var supported = {
oses: {},
arches: {},
libcs: {},
formats: {},
};
@@ -102,6 +94,16 @@ function normalize(all) {
}
}
}
// Hacky-doo for musl
// TODO 'libc' some sort of glibc vs musl tag?
if (!rel._musl_native) {
if (!rel._musl) {
if (/(\b|\.|_|-)(musl)(\b|\.|_|-)/.test(rel.download)) {
rel._musl = true;
}
}
}
supported.oses[rel.os] = true;
if (!rel.arch) {
@@ -121,60 +123,6 @@ function normalize(all) {
}
supported.arches[rel.arch] = true;
// note: depends on rel.os
if (!rel.libc) {
let isMusl;
let isMsvc;
let isStatic;
let isGnu;
// extra blocks to prevent copy pasta errors
{
let muslRe = /(\b|_)(musl)(\b|_)/i;
isMusl = muslRe.test(rel.download) || muslRe.test(rel.name);
}
{
let msvcRe = /(\b|_)(msvc)(\b|_)/i;
isMsvc = msvcRe.test(rel.download) || msvcRe.test(rel.name);
}
{
let staticRe = /(\b|_)(static)(\b|_)/i;
isStatic = staticRe.test(rel.download) || staticRe.test(rel.name);
}
{
let gnuRe = /(\b|_)(gnu|glibc|libc)(\b|_)/i;
isGnu = gnuRe.test(rel.download) || gnuRe.test(rel.name);
}
if (isMusl) {
// we specifically tag things that need musl++ in their own releases
rel.libc = 'none';
} else if (isStatic) {
rel.libc = 'none';
} else if (isGnu) {
rel.libc = 'gnu';
if (rel.os === 'windows') {
// windows gnu is static
rel.libc = 'none';
} else if (rel.os === 'darwin') {
// if glibc is required on macos, it'll be static
rel.libc = 'none';
}
} else if (isMsvc) {
rel.libc = 'msvc';
} else {
// The default is no requirement for any particular libc
// (Go, Zig, POSIX Shell, JS, etc)
// and hopefully we never have to worry about mingw and friends
rel.libc = 'none';
}
}
supported.libcs[rel.libc] = true;
var tarExt;
if (!rel.ext) {
// pkg-v1.0.tar.gz => ['gz', 'tar', '0', 'pkg-v1']
@@ -231,9 +179,6 @@ function normalize(all) {
all.arches = Object.keys(supported.arches).filter(function (name) {
return maps.arches[name];
});
all.libcs = Object.keys(supported.libcs).filter(function (name) {
return maps.libcs[name];
});
all.formats = Object.keys(supported.formats).filter(function (name) {
return maps.formats[name];
});
@@ -254,5 +199,4 @@ module.exports._debug = function (all) {
// NOT in order of priority (which would be tar, xz, zip, ...)
module.exports.formats = formats;
module.exports.arches = arches;
module.exports.libcs = libcs;
module.exports.formatsMap = maps.formats;

View File

@@ -27,11 +27,10 @@ function padScript(txt) {
return txt.replace(/^/g, ' ');
}
var BAD_SH_RE = /[<>'"`$\\]/;
Releases.renderBash = async function (
pkgdir,
rel,
{ baseurl, pkg, tag, ver, os = '', arch = '', libc = '', formats },
{ baseurl, pkg, tag, ver, os = '', arch = '', formats },
) {
if (!Array.isArray(formats)) {
formats = [];
@@ -39,116 +38,138 @@ Releases.renderBash = async function (
if (!tag) {
tag = '';
}
let installTxt = await fs.promises.readFile(
path.join(pkgdir, 'install.sh'),
'utf8',
);
installTxt = padScript(installTxt);
var vers = rel.version.split('.');
var v = {
major: vers.shift() || '',
minor: vers.shift() || '',
patch: vers.join('.').replace(/[+\-].*/, ''),
build: vers
.join('.')
.replace(/[^+\-]*/, '')
.replace(/^-/, ''),
};
var pkgFile = rel.filename || rel.name;
let tplTxt = await fs.promises.readFile(
path.join(__dirname, 'install-package.tpl.sh'),
'utf8',
);
// ex: 'node@lts' or 'node'
var webiPkg = pkg;
if (ver) {
webiPkg += `@${ver}`;
}
return fs.promises
.readFile(path.join(pkgdir, 'install.sh'), 'utf8')
.then(function (installTxt) {
installTxt = padScript(installTxt);
var vers = rel.version.split('.');
var v = {
major: vers.shift() || '',
minor: vers.shift() || '',
patch: vers.join('.').replace(/[+\-].*/, ''),
build: vers
.join('.')
.replace(/[^+\-]*/, '')
.replace(/^-/, ''),
};
var pkgFile = rel.filename || rel.name;
return fs.promises
.readFile(path.join(__dirname, 'template.sh'), 'utf8')
.then(function (tplTxt) {
// ex: 'node@lts' or 'node'
var webiPkg = pkg;
if (ver) {
webiPkg += `@${ver}`;
}
return (
tplTxt
.replace(/CHEATSHEET_URL/g, `${baseurl}/${pkg}`)
.replace(/^\s*#?WEBI_PKG=.*/m, `WEBI_PKG='${webiPkg}'`)
.replace(/^\s*#?WEBI_HOST=.*/m, `WEBI_HOST='${baseurl}'`)
.replace(/^\s*#?WEBI_OS=.*/m, `WEBI_OS='${os}'`)
.replace(/^\s*#?WEBI_ARCH=.*/m, `WEBI_ARCH='${arch}'`)
.replace(/^\s*#?WEBI_TAG=.*/m, `WEBI_TAG='${tag}'`)
.replace(
/^\s*#?WEBI_RELEASES=.*/m,
"WEBI_RELEASES='" +
baseurl +
'/api/releases/' +
pkg +
'@' +
tag +
'.tab?os=' +
rel.os +
'&arch=' +
rel.arch +
'&formats=' +
formats.join(',') +
'&pretty=true' +
"'",
)
.replace(
/^\s*#?WEBI_CSV=.*/m,
"WEBI_CSV='" +
[
rel.version,
rel.lts,
rel.channel,
rel.date,
rel.os,
rel.arch,
rel.ext,
'-',
rel.download,
rel.name,
rel.comment || '',
]
.join(',')
.replace(/'/g, '') +
"'",
)
.replace(
/^\s*#?WEBI_VERSION=.*/m,
"WEBI_VERSION='" + rel.version + "'",
)
.replace(/^\s*#?WEBI_MAJOR=.*/m, 'WEBI_MAJOR=' + v.major)
.replace(/^\s*#?WEBI_MINOR=.*/m, 'WEBI_MINOR=' + v.minor)
.replace(/^\s*#?WEBI_PATCH=.*/m, 'WEBI_PATCH=' + v.patch)
.replace(/^\s*#?WEBI_BUILD=.*/m, 'WEBI_BUILD=' + v.build)
.replace(
/^\s*#?WEBI_GIT_TAG=.*/m,
"WEBI_GIT_TAG='" + rel.git_tag + "'",
)
.replace(/^\s*#?WEBI_LTS=.*/m, 'WEBI_LTS=' + rel.lts)
.replace(/^\s*#?WEBI_CHANNEL=.*/m, 'WEBI_CHANNEL=' + rel.channel)
.replace(
/^\s*#?WEBI_EXT=.*/m,
'WEBI_EXT=' + rel.ext.replace(/tar.*/, 'tar'),
)
.replace(
/^\s*#?WEBI_FORMATS=.*/m,
"WEBI_FORMATS='" + formats.join(',') + "'",
)
.replace(
/^\s*#?WEBI_PKG_URL=.*/m,
"WEBI_PKG_URL='" + rel.download + "'",
)
// TODO replace WEBI_PKG_FILE (which is sometimes a dir)
.replace(
/^\s*#?WEBI_PKG_PATHNAME=.*/m,
"WEBI_PKG_PATHNAME='" + pkgFile + "'",
)
// TODO deprecate
.replace(
/^\s*#?WEBI_PKG_FILE=.*/m,
"WEBI_PKG_FILE='" + pkgFile + "'",
)
// PKG details
.replace(/^\s*#?PKG_NAME=.*/m, "PKG_NAME='" + pkg + "'")
.replace(
/^\s*#?PKG_OSES=.*/m,
"PKG_OSES='" + ((rel && rel.oses) || []).join(',') + "'",
)
.replace(
/^\s*#?PKG_ARCHES=.*/m,
"PKG_ARCHES='" + ((rel && rel.arches) || []).join(',') + "'",
)
.replace(
/^\s*#?PKG_FORMATS=.*/m,
"PKG_FORMATS='" + ((rel && rel.formats) || []).join(',') + "'",
)
// $', $0, ... $9, $`, $&, and $_ all have special meaning
// (see https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/RegExp)
// However, it can be escaped with $$ (which must be escaped with $$)
let releaseParams = new URLSearchParams({
os: rel.os,
arch: rel.arch,
libc: rel.libc,
formats: formats.join(','),
pretty: true,
});
let releaseSearch = releaseParams.toString();
releaseSearch = releaseSearch.replace(/%2C/g, ',');
let releaseUrl = `/api/releases/${pkg}@${tag}.tab?${releaseSearch}`;
let releaseCsv = [
rel.version,
rel.lts,
rel.channel,
rel.date,
rel.os,
rel.arch,
rel.ext,
'-',
rel.download,
rel.name,
rel.comment || '',
]
.join(',')
.replace(/'/g, '');
let envReplacements = [
['WEBI_PKG', webiPkg],
['WEBI_HOST', baseurl],
['WEBI_OS', os],
['WEBI_ARCH', arch],
['WEBI_LIBC', libc],
['WEBI_TAG', tag],
['WEBI_RELEASES', `${baseurl}/${releaseUrl}`],
['WEBI_CSV', releaseCsv],
['WEBI_VERSION', rel.version],
['WEBI_MAJOR', v.major],
['WEBI_MINOR', v.minor],
['WEBI_PATCH', v.patch],
['WEBI_BUILD', v.build],
['WEBI_GIT_BRANCH', rel.git_branch || rel.git_tag],
['WEBI_GIT_TAG', rel.git_tag], // TODO replace with branch
['WEBI_LTS', rel.lts],
['WEBI_CHANNEL', rel.channel],
['WEBI_EXT', rel.ext.replace(/tar.*/, 'tar')],
['WEBI_FORMATS', formats.join(',')],
['WEBI_PKG_URL', rel.download],
['WEBI_PKG_PATHNAME', pkgFile],
['WEBI_PKG_FILE', pkgFile], // TODO replace with pathname
['PKG_NAME', pkg],
['PKG_OSES', rel.oses],
['PKG_ARCHES', rel.arches],
['PKG_LIBCS', rel.libcs],
['PKG_FORMATS', (rel.formats || []).join(',')],
];
for (let env of envReplacements) {
let name = env[0];
let value = env[1];
// Ex:
// #export WEBI_FOO=xyz => export WEBI_FOO='123'
// export WEBI_FOO= => export WEBI_FOO='123'
let envRe = new RegExp(
`^[ \\t]*#?[ \\t]*(export\\s)?[ \\t]*(${name})=.*`,
'm',
);
if (BAD_SH_RE.test(value)) {
throw new Error(`key '${name}' has invalid value '${value}'`);
}
tplTxt = tplTxt.replace(envRe, `$1$2='${value}'`);
}
tplTxt = tplTxt
.replace(/CHEATSHEET_URL/g, `${baseurl}/${pkg}`)
// $', $0, ... $9, $`, $&, and $_ all have special meaning
// (see https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/RegExp)
// However, it can be escaped with $$ (which must be escaped with $$)
.replace(reInstallTpl, '\n' + installTxt.replace(/\$/g, '$$$$'));
return tplTxt;
.replace(reInstallTpl, '\n' + installTxt.replace(/\$/g, '$$$$'))
);
});
});
};
Releases.renderPowerShell = async function (
pkgdir,
rel,
{ baseurl, pkg, tag, ver, os, arch, libc = '', formats },
{ baseurl, pkg, tag, ver, os, arch, formats },
) {
if (!Array.isArray(formats)) {
formats = [];
@@ -156,65 +177,64 @@ Releases.renderPowerShell = async function (
if (!tag) {
tag = '';
}
let installTxt = await fs.promises.readFile(
path.join(pkgdir, 'install.ps1'),
'utf8',
);
installTxt = padScript(installTxt);
/*
var vers = rel.version.split('.');
var v = {
major: vers.shift() || '',
minor: vers.shift() || '',
patch: vers.join('.').replace(/[+\-].*$/, ''),
build: vers
.join('.')
.replace(/[^+\-]*()/, '')
.replace(/^-/, '')
};
*/
let tplTxt = await fs.promises.readFile(
path.join(__dirname, 'install-package.tpl.ps1'),
'utf8',
);
var pkgver = pkg + '@' + ver;
return (
tplTxt
.replace(
/^(#)?\$Env:WEBI_LIBC\s*=.*/im,
"$Env:WEBI_LIBC = '" + libc + "'",
)
.replace(
/^(#)?\$Env:WEBI_HOST\s*=.*/im,
"$Env:WEBI_HOST = '" + baseurl + "'",
)
.replace(
/^(#)?\$Env:WEBI_PKG\s*=.*/im,
"$Env:WEBI_PKG = '" + pkgver + "'",
)
.replace(/^(#)?\$Env:PKG_NAME\s*=.*/im, "$Env:PKG_NAME = '" + pkg + "'")
.replace(
/^(#)?\$Env:WEBI_VERSION\s*=.*/im,
"$Env:WEBI_VERSION = '" + rel.version + "'",
)
.replace(
/^(#)?\$Env:WEBI_GIT_TAG\s*=.*/im,
"$Env:WEBI_GIT_TAG = '" + rel.git_tag + "'",
)
.replace(
/^(#)?\$Env:WEBI_PKG_URL\s*=.*/im,
"$Env:WEBI_PKG_URL = '" + rel.download + "'",
)
// TODO replace WEBI_PKG_FILE (which is sometimes a dir)
.replace(
/^(#)?\$Env:WEBI_PKG_PATHNAME\s*=.*/im,
"$Env:WEBI_PKG_PATHNAME = '" + rel.name + "'",
)
// TODO deprecate
.replace(
/^(#)?\$Env:WEBI_PKG_FILE\s*=.*/im,
"$Env:WEBI_PKG_FILE = '" + rel.name + "'",
)
.replace(reInstallTpl, '\n' + installTxt)
);
return fs.promises
.readFile(path.join(pkgdir, 'install.ps1'), 'utf8')
.then(function (installTxt) {
installTxt = padScript(installTxt);
/*
var vers = rel.version.split('.');
var v = {
major: vers.shift() || '',
minor: vers.shift() || '',
patch: vers.join('.').replace(/[+\-].*$/, ''),
build: vers
.join('.')
.replace(/[^+\-]*()/, '')
.replace(/^-/, '')
};
*/
return fs.promises
.readFile(path.join(__dirname, 'template.ps1'), 'utf8')
.then(function (tplTxt) {
var pkgver = pkg + '@' + ver;
return (
tplTxt
.replace(
/^(#)?\$Env:WEBI_HOST\s*=.*/im,
"$Env:WEBI_HOST = '" + baseurl + "'",
)
.replace(
/^(#)?\$Env:WEBI_PKG\s*=.*/im,
"$Env:WEBI_PKG = '" + pkgver + "'",
)
.replace(
/^(#)?\$Env:PKG_NAME\s*=.*/im,
"$Env:PKG_NAME = '" + pkg + "'",
)
.replace(
/^(#)?\$Env:WEBI_VERSION\s*=.*/im,
"$Env:WEBI_VERSION = '" + rel.version + "'",
)
.replace(
/^(#)?\$Env:WEBI_GIT_TAG\s*=.*/im,
"$Env:WEBI_GIT_TAG = '" + rel.git_tag + "'",
)
.replace(
/^(#)?\$Env:WEBI_PKG_URL\s*=.*/im,
"$Env:WEBI_PKG_URL = '" + rel.download + "'",
)
// TODO replace WEBI_PKG_FILE (which is sometimes a dir)
.replace(
/^(#)?\$Env:WEBI_PKG_PATHNAME\s*=.*/im,
"$Env:WEBI_PKG_PATHNAME = '" + rel.name + "'",
)
// TODO deprecate
.replace(
/^(#)?\$Env:WEBI_PKG_FILE\s*=.*/im,
"$Env:WEBI_PKG_FILE = '" + rel.name + "'",
)
.replace(reInstallTpl, '\n' + installTxt)
);
});
});
};

View File

@@ -1,9 +1,5 @@
'use strict';
var Installers = module.exports;
var Crypto = require('crypto');
var Fs = require('fs/promises');
var path = require('path');
var uaDetect = require('./ua-detect.js');
@@ -13,37 +9,13 @@ var Releases = require('./releases.js');
// handlers caching and transformation, probably should be broken down
var getReleases = require('./transform-releases.js');
Installers.INSTALLERS_DIR = path.join(__dirname, '..');
Installers.serveInstaller = async function (
baseurl,
ua,
pkg,
tag,
ext,
formats,
libc,
) {
let [rel, opts] = await Installers.helper({
ua,
pkg,
tag,
formats,
libc,
});
Object.assign(opts, {
baseurl,
});
var installersDir = path.join(__dirname, '..');
var pkgdir = path.join(Installers.INSTALLERS_DIR, pkg);
if ('ps1' === ext) {
return Releases.renderPowerShell(pkgdir, rel, opts);
}
return Releases.renderBash(pkgdir, rel, opts);
};
Installers.helper = async function ({ ua, pkg, tag, formats, libc }) {
serveInstaller.serveInstaller = serveInstaller;
module.exports = serveInstaller;
async function serveInstaller(baseurl, ua, pkg, tag, ext, formats) {
// TODO put some of this in a middleware? or common function?
// TODO maybe move package/version/lts/channel detection into getReleases
var ver = tag.replace(/^v/, '');
var lts;
var channel;
@@ -72,21 +44,12 @@ Installers.helper = async function ({ ua, pkg, tag, formats, libc }) {
break;
}
// TODO maybe move package/version/lts/channel detection into getReleases
var myOs = uaDetect.os(ua);
var myArch = uaDetect.arch(ua);
var myLibc;
if (libc) {
myLibc = uaDetect.libc(libc);
}
if (!myLibc) {
myLibc = uaDetect.libc(ua);
}
if (!myLibc) {
myLibc = 'libc';
}
var myLibc = uaDetect.libc(ua);
let cfg = await packages.get(pkg);
let releaseQuery = {
let rels = await getReleases({
pkg: cfg.alias || pkg,
ver,
os: myOs,
@@ -94,147 +57,30 @@ Installers.helper = async function ({ ua, pkg, tag, formats, libc }) {
libc: myLibc,
lts,
channel,
// TODO use formats for sorting, not exclusion
// (it's better to install xz or report an error to install zip)
formats,
limit: 1,
};
let rels = await getReleases(releaseQuery);
});
var rel = rels.releases[0];
var pkgdir = path.join(installersDir, pkg);
var opts = {
baseurl,
pkg: cfg.alias || pkg,
ver,
tag,
os: myOs,
arch: myArch,
libc: myLibc,
lts,
channel,
formats,
limit: 1,
};
rel = Object.assign(
{
oses: rels.oses,
arches: rels.arches,
libcs: rels.libcs,
formats: rels.formats,
},
rel,
);
rel.oses = rels.oses;
rel.arches = rels.arches;
rel.formats = rels.formats;
return [rel, opts];
};
var CURL_PIPE_PS1_BOOT = path.join(__dirname, 'bootstrap.ps1');
var CURL_PIPE_SH_BOOT = path.join(__dirname, 'bootstrap.sh');
var BAD_SH_RE = /[<>'"`$\\]/;
Installers.getPosixCurlPipeBootstrap = async function ({ baseurl, pkg, ver }) {
let bootTxt = await Fs.readFile(CURL_PIPE_SH_BOOT, 'utf8');
var webiPkg = [pkg, ver].filter(Boolean).join('@');
var webiChecksum = await Installers.getWebiShChecksum();
var envReplacements = [
['WEBI_PKG', webiPkg],
['WEBI_HOST', baseurl],
['WEBI_CHECKSUM', webiChecksum],
];
for (let env of envReplacements) {
let name = env[0];
let value = env[1];
// TODO create REs once, in higher scope
let envRe = new RegExp(
`^[ \\t]*#?[ \\t]*(export\\s)?[ \\t]*(${name})=.*`,
'm',
);
if (BAD_SH_RE.test(value)) {
throw new Error(`key '${name}' has invalid value '${value}'`);
}
bootTxt = bootTxt.replace(envRe, `$1$2='${value}'`);
if ('ps1' === ext) {
return Releases.renderPowerShell(pkgdir, rel, opts);
}
// TODO init config here
//bootTxt.replace(/CHEATSHEET_URL/g, `${Config.cheatUrl}/${pkg}`);
return bootTxt;
};
Installers.getPwshCurlPipeBootstrap = async function ({
baseurl,
pkg,
ver,
exename,
}) {
let bootTxt = await Fs.readFile(CURL_PIPE_PS1_BOOT, 'utf8');
var webiPkg = [pkg, ver].filter(Boolean).join('@');
//var webiChecksum = await Installers.getWebiPs1Checksum();
var envReplacements = [
['Env:WEBI_PKG', webiPkg],
['Env:WEBI_HOST', baseurl],
//['Env:WEBI_CHECKSUM', webiChecksum],
['baseurl', baseurl],
['exename', exename],
['version', ver],
];
for (let env of envReplacements) {
let name = env[0];
let value = env[1];
if (BAD_SH_RE.test(value)) {
throw new Error(`key '${name}' has invalid value '${value}'`);
}
let tplRe = new RegExp(`{{ (${name}) }}`, 'g');
bootTxt = bootTxt.replace(tplRe, `${value}`);
// let envRe = new RegExp(`^[ \\t]*#?[ \\t]*($$${name})[ \\t]*=.*`, 'im');
// bootTxt = bootTxt.replace(envRe, `$$${name} = '${value}'`);
let setRe = new RegExp(
`(#[ \\t]*)?(\\$${name})[ \\t]*=[ \\t]['"].*['"][ \\t]`,
'im',
);
bootTxt = bootTxt.replace(setRe, `$$${name} = '${value}'`);
}
// TODO init config here
//bootTxt.replace(/CHEATSHEET_URL/g, `${Config.cheatUrl}/${pkg}`);
return bootTxt;
};
var _webiShMeta = {
stale: 10 * 1000,
updated_at: 0,
checksum: '',
mtime: 0,
};
Installers.getWebiShChecksum = async function () {
let now = Date.now();
let ago = now - _webiShMeta.updated_at;
if (ago <= _webiShMeta.stale) {
return _webiShMeta.checksum;
}
let webiPath = path.join(__dirname, '../webi/webi.sh');
let stat = await Fs.stat(webiPath);
if (stat.mtimeMs === _webiShMeta.mtime) {
return _webiShMeta.checksum;
}
let webiBuf = await Fs.readFile(webiPath, null);
let webiHash = Crypto.createHash('sha1').update(webiBuf).digest('hex');
let webiChecksum = webiHash.slice(0, 8);
_webiShMeta.mtime = stat.mtimeMs;
_webiShMeta.updated_at = now;
_webiShMeta.checksum = webiChecksum;
return _webiShMeta.checksum;
};
return Releases.renderBash(pkgdir, rel, opts);
}

View File

@@ -37,9 +37,9 @@ $Env:WEBI_HOST = 'https://webinstall.dev'
Push-Location $Env:USERPROFILE
# Make paths
New-Item -Path "$Env:USERPROFILE\Downloads" -ItemType Directory -Force | Out-Null
New-Item -Path "$Env:USERPROFILE\.local\bin" -ItemType Directory -Force | Out-Null
New-Item -Path "$Env:USERPROFILE\.local\opt" -ItemType Directory -Force | Out-Null
New-Item -Path Downloads -ItemType Directory -Force | Out-Null
New-Item -Path .local\bin -ItemType Directory -Force | Out-Null
New-Item -Path .local\opt -ItemType Directory -Force | Out-Null
# {{ baseurl }}
# {{ version }}

View File

@@ -8,18 +8,13 @@ __bootstrap_webi() {
my_libc=''
if ldd /bin/ls 2> /dev/null | grep -q 'musl' 2> /dev/null; then
my_libc='musl'
elif uname -o | grep -q 'GNU' || uname -s | grep -q 'Linux'; then
my_libc='gnu'
else
my_libc='libc'
my_libc=' musl-native'
fi
#WEBI_PKG=
#PKG_NAME=
#WEBI_OS=
#WEBI_ARCH=
#WEBI_LIBC=
#WEBI_HOST=
#WEBI_RELEASES=
#WEBI_CSV=
@@ -40,9 +35,8 @@ __bootstrap_webi() {
#WEBI_PKG_PATHNAME=
#PKG_OSES=
#PKG_ARCHES=
#PKG_LIBCS=
#PKG_FORMATS=
WEBI_UA="$(uname -s)/$(uname -r) $(uname -m)/unknown ${my_libc}"
WEBI_UA="$(uname -s)/$(uname -r) $(uname -m)/unknown${my_libc}"
WEBI_PKG_DOWNLOAD=""
WEBI_DOWNLOAD_DIR="${HOME}/Downloads"
if command -v xdg-user-dir > /dev/null; then
@@ -170,20 +164,15 @@ __bootstrap_webi() {
return 0
fi
echo >&2 "Error: no '${PKG_NAME:-"Unknown Package"}@${WEBI_TAG:-"Unknown Tag"}' release for '${WEBI_OS:-"Unknown OS"}' (${WEBI_LIBC:-"Unknown Libc"}) on '${WEBI_ARCH:-"Unknown CPU"}' as one of '${WEBI_FORMATS:-"Unknown File Type"}'"
echo >&2 " '$PKG_NAME' is available for '$PKG_OSES' ($PKG_LIBCS) on '$PKG_ARCHES' as one of '$PKG_FORMATS'"
echo >&2 "Error: no '$PKG_NAME' release for '${WEBI_OS-}' on '$WEBI_ARCH' as one of '$WEBI_FORMATS' by the tag '${WEBI_TAG-}'"
echo >&2 " '$PKG_NAME' is available for '$PKG_OSES' on '$PKG_ARCHES' as one of '$PKG_FORMATS'"
echo >&2 " (check that the package name and version are correct)"
echo >&2 ""
my_release_url="$(
echo "$WEBI_RELEASES" |
sed 's:?.*::'
)"
my_release_params="$(
echo "$WEBI_RELEASES" |
sed 's:.*?:?:'
sed 's:\?.*::'
)"
echo >&2 " Double check at ${my_release_url}"
echo >&2 " ${my_release_params}"
echo >&2 ""
exit 1
@@ -559,7 +548,7 @@ __bootstrap_webi() {
if [ -z "${WEBI_WELCOME-}" ]; then
echo ""
printf "Thanks for using webi to install '\e[32m%s\e[0m' on '\e[33m%s (%s) %s\e[0m'.\n" "${WEBI_PKG:-"Unknown Package"}" "$(uname -s)" "${WEBI_LIBC:-"Unknown Libc"}" "$(uname -m)"
printf "Thanks for using webi to install '\e[32m%s\e[0m' on '\e[33m%s/%s\e[0m'.\n" "${WEBI_PKG-}" "$(uname -s)" "$(uname -m)"
echo "Have a problem? Experience a bug? Please let us know:"
printf " \e[2m\e[36mhttps://github.com/webinstall/webi-installers/issues\e[0m\n"
echo ""

View File

@@ -33,8 +33,7 @@ var os = require('os');
var fs = require('fs');
var path = require('path');
var Releases = require('./releases.js');
var ServeInstaller = require('./serve-installer.js');
var uaDetect = require('./ua-detect.js');
var pkg = process.argv[2].split('@');
var pkgdir = pkg[0];
var pkgtag = pkg[1] || '';
@@ -43,7 +42,6 @@ var nodes = fs.readdirSync(pkgdir);
nodes.forEach(function (node) {
nodesMap[node] = true;
});
var baseurl = 'https://webinstall.dev';
var maxLen = 0;
console.info('');
@@ -64,60 +62,90 @@ console.info('Has the necessary files?');
});
console.info('');
Releases.get(path.join(process.cwd(), pkgdir)).then(async function (all) {
Releases.get(path.join(process.cwd(), pkgdir)).then(function (all) {
var pkgname = path.basename(pkgdir.replace(/\/$/, ''));
var nodeOs = os.platform();
var nodeOsRelease = os.release();
var nodeArch = os.arch();
var nodeLibc = 'libc';
if (process.platform === 'linux') {
nodeLibc = 'gnu';
let isUnofficial =
process.config.variables.node_release_urlbase.includes('unofficial');
if (isUnofficial) {
nodeLibc = 'musl';
}
}
var osrel = os.platform() + '-' + os.release();
var arch = os.arch();
var formats = ['exe', 'xz', 'tar', 'zip', 'git'];
let [rel, opts] = await ServeInstaller.helper({
ua: `${nodeOs}/${nodeOsRelease} ${nodeArch}/unknown ${nodeLibc}`,
pkg: pkgname,
tag: pkgtag || '',
formats: formats,
libc: nodeLibc,
});
Object.assign(
{
ver: '',
lts: null,
channel: '',
os: '',
arch: '',
limit: 0,
},
opts,
{
baseurl,
},
);
var rel;
//var releases = [];
for (let _rel of all.releases) {
for (let ext of formats) {
let isSupported = _rel.ext.match(ext);
if (!isSupported) {
continue;
}
}
if (_rel.channel !== 'stable') {
continue;
}
if (_rel.os !== '*') {
let curOs = uaDetect.os(osrel);
if (_rel.os !== curOs) {
continue;
}
}
if (_rel.arch !== '*') {
let curArch = uaDetect.arch(arch);
if (_rel.arch !== curArch) {
continue;
}
}
if (pkgtag) {
if (_rel.tag !== pkgtag) {
let pkgtagRe = new RegExp('^' + pkgtag);
let matchesVersion = pkgtagRe.test(_rel.version);
if (!matchesVersion) {
continue;
}
}
}
rel = _rel;
break;
}
if (!rel) {
console.error(
`Error: ❌ no release found for @${pkgtag}?os=${nodeOs}&arch=${nodeArch}&libc=${nodeLibc}&formats=${formats}`,
`Error: ❌ no release found for os=${osrel}, arch=${arch}, and tag=${pkgtag}`,
);
process.exit(1);
return;
}
rel.oses = all.oses;
rel.arches = all.arches;
rel.formats = all.formats;
console.info('');
console.info('Found release matching current os, arch, and tag:');
console.info(rel);
console.info('');
return Promise.all([
Releases.renderBash(pkgdir, rel, opts).catch(function () {}),
Releases.renderPowerShell(pkgdir, rel, opts).catch(function () {}),
Releases.renderBash(pkgdir, rel, {
baseurl: 'https://webinstall.dev',
pkg: pkgname,
tag: pkgtag || '',
ver: '',
os: osrel,
arch,
formats: formats,
}).catch(function () {}),
Releases.renderPowerShell(pkgdir, rel, {
baseurl: 'https://webinstall.dev',
pkg: pkgname,
tag: pkgtag || '',
ver: '',
os: osrel,
arch,
formats: formats,
}).catch(function () {}),
]).then(function (scripts) {
var bashTxt = scripts[0];
var ps1Txt = scripts[1];
@@ -141,9 +169,5 @@ Releases.get(path.join(process.cwd(), pkgdir)).then(async function (all) {
console.info('\tNEEDS MANUAL TEST: powershell.exe %s', ps1File);
}
console.info('');
setTimeout(function () {
console.warn(`[warn] dangling event loop handle`);
process.exit(0);
}, 300).unref();
});
});

View File

@@ -2,6 +2,7 @@
var path = require('path');
var Releases = require('./releases.js');
var uaDetect = require('./ua-detect.js');
var cache = {};
//var staleAge = 5 * 1000;
@@ -53,14 +54,21 @@ function createFormatsSorter(formats) {
return 1;
}
// rank builds that don't depend on any form of libc first
if (a.libc === 'none' && b.libc !== 'none') {
return -1;
}
if (a.libc !== 'none' && b.libc === 'none') {
// Hacky-doo for musl-native: prefer non-musl
if (a._musl_native && !b._musl_native) {
return 1;
}
if (!a._musl_native && b._musl_native) {
return -1;
}
// Hacky-doo for linux: prefer musl
if (a._musl && !b._musl) {
return -1;
}
if (!a._musl && b._musl) {
return 1;
}
return 0;
};
}
@@ -189,20 +197,13 @@ async function filterReleases(
}
}
if (rel.libc !== 'none') {
let releaseRequiresMusl = rel.libc === 'musl';
// goal: handle non-glibc (Alpine / Docker / musl)
let osHasMusl = libc === 'musl';
if (osHasMusl) {
// goal: fail if dependent on libc
let releaseRequiresLibc = rel.libc === 'gnu';
if (releaseRequiresLibc) {
return false;
}
} else if (releaseRequiresMusl) {
// goal: don't use musl++ on glibc (Ubuntu, GNU, etc)
// Hacky-doo for linux musl
if (libc === uaDetect.MUSL_NATIVE) {
if (!rel._musl && !rel._musl_native) {
return false;
}
} else if (rel._musl_native) {
return false;
}
if (lts) {
@@ -362,20 +363,20 @@ module.exports = function getReleases({
date: '1970-01-01',
os: os || '-',
arch: arch || '-',
libc: libc || '-',
_musl: undefined,
_musl_native: undefined,
ext: 'err',
download: 'https://example.com/doesntexist.ext',
comment:
'No matches found. Could be bad or missing version info' +
',' +
"Check query parameters. Should be something like '/api/releases/{package}@{version}.tab?os={macos|linux|windows|-}&arch={amd64|x86|aarch64|arm64|armv7l|-}&libc={musl|gnu|msvc|libc|static}&limit=10'",
"Check query parameters. Should be something like '/api/releases/{package}@{version}.tab?os={macos|linux|windows|-}&arch={amd64|x86|aarch64|arm64|armv7l|-}&limit=100'",
},
];
}
return {
oses: all.oses,
arches: all.arches,
libcs: all.libcs,
formats: all.formats,
releases: releases,
};
@@ -391,7 +392,7 @@ if (require.main === module) {
os: 'macos',
arch: 'amd64',
lts: true,
libc: 'libc',
libc: '',
channel: 'stable',
formats: ['tar', 'exe', 'zip', 'xz', 'dmg', 'pkg'],
limit: 10,

View File

@@ -2,6 +2,10 @@
var uaDetect = module.exports;
const MUSL_NATIVE = 'musl-native';
uaDetect.MUSL_NATIVE = MUSL_NATIVE;
function getRequest(req) {
var ua = req.headers['user-agent'] || '';
var os = req.query.os;
@@ -96,55 +100,19 @@ function getLibc(ua) {
return '-';
}
// How to see a bunch of target host quadruples:
// go tool dist list
// rustup target list
// zig targets | jq -r '.libc[]' | sort -
// Use native 'libc' information, if provided
//
// Generally, we prefer 'musl' builds because they DO work on glibc systems (Ubuntu),
// but 'glibc' builds will NOT work on musl systems (Alpine / Docker).
//
// However, there are a few instances (ex: Node.js), where the 'musl' builds
// DO NOT work on glibc systems.
{
let muslRe = /(\b|_)(musl)(\b|_)/i;
if (muslRe.test(ua)) {
return 'musl';
}
if (ua.match(MUSL_NATIVE)) {
return MUSL_NATIVE;
}
{
let msvcRe = /(\b|_)(msvc|windows|microsoft)(\b|_)/i;
if (msvcRe.test(ua)) {
return 'msvc';
}
}
{
let gnuRe = /(\b|_)(gnu|glibc|linux)(\b|_)/i;
if (gnuRe.test(ua)) {
return 'gnu';
}
}
{
let libcRe = /(\b|_)(libc)(\b|_)/i;
if (libcRe.test(ua)) {
return 'libc';
}
}
{
let darwinRe = /(\b|_)(darwin)(\b|_)/i;
if (darwinRe.test(ua)) {
// not sure whether this should be "darwin" or "libc" or "none"
// https://opensource.apple.com/source/Libc/
return 'libc';
}
}
return 'libc';
// TODO handle explicit invalid different
return '';
}
uaDetect.os = getOs;

View File

@@ -28,7 +28,7 @@ IF ($my_arch -eq "AMD64") {
}
}
$Env:WEBI_UA = "Windows/10+ $my_arch msvc"
$Env:WEBI_UA = "Windows/10 $my_arch"
$exename = $args[0]
# Switch to userprofile
@@ -100,7 +100,7 @@ if ($exename -eq "-V" -or $exename -eq "--version" -or $exename -eq "version" -o
# Fetch <whatever>.ps1
# TODO detect formats
$PKG_URL = "$Env:WEBI_HOST/api/installers/$exename.ps1?formats=zip,exe,tar,git&libc=msvc"
$PKG_URL = "$Env:WEBI_HOST/api/installers/$exename.ps1?formats=zip,exe,tar,git"
Write-Output "Downloading $PKG_URL"
# Invoke-WebRequest -UserAgent "Windows amd64" "$PKG_URL" -OutFile ".\.local\tmp\$exename.install.ps1"
& curl.exe -fsSL -A "$Env:WEBI_UA" "$PKG_URL" -o .\.local\tmp\$exename.install.ps1

27
_webi/webi.bat Normal file
View File

@@ -0,0 +1,27 @@
@echo off
pushd "%userprofile%" || goto :error
IF NOT EXIST .local (
mkdir .local || goto :error
)
IF NOT EXIST .local\bin (
mkdir .local\bin || goto :error
)
IF NOT EXIST .local\opt (
mkdir .local\opt || goto :error
)
echo Downloading and installing %1
powershell $ProgressPreference = 'SilentlyContinue'; Invoke-WebRequest https://webinstall.dev/packages/%1/install.ps1 -OutFile %1-webinstall.bat || goto :error
rem TODO only add if it's not in there already
PATH .local\bin;%PATH%
call %1-webinstall.bat || goto :error
del %1-webinstall.bat || goto :error
popd
goto :EOF
:error
echo Failed with error #%errorlevel%.
exit /b %errorlevel%

1
_webi/webi.ps1.bat Normal file
View File

@@ -0,0 +1 @@
powershell -ExecutionPolicy Bypass .\.local\bin\webi-pwsh.ps1 %1

View File

@@ -8,13 +8,10 @@ let targets = {
x86win: {
os: 'windows',
arch: 'x86',
libc: 'msvc',
},
x64win: {
os: 'windows',
arch: 'amd64',
// https://github.com/wez/atomicparsley/issues/6#issuecomment-1364523028
libc: 'msvc',
},
x64mac: {
os: 'macos',
@@ -23,12 +20,11 @@ let targets = {
x64lin: {
os: 'linux',
arch: 'amd64',
libc: 'gnu',
},
x64musl: {
os: 'linux',
arch: 'amd64',
libc: 'musl',
_musl_native: true,
},
};

View File

@@ -8,19 +8,19 @@
$pkg_cmd_name = "cmake"
$pkg_dst_cmd = "$Env:USERPROFILE\.local\opt\cmake\bin\cmake.exe"
$pkg_dst_bin = "$Env:USERPROFILE\.local\opt\cmake\bin"
$pkg_dst_dir = "$Env:USERPROFILE\.local\opt\cmake"
$pkg_dst = "$pkg_dst_dir"
$pkg_dst = "$pkg_dst_cmd"
$pkg_src_cmd = "$Env:USERPROFILE\.local\opt\cmake-v$Env:WEBI_VERSION\bin\cmake.exe"
$pkg_src_bin = "$Env:USERPROFILE\.local\opt\cmake-v$Env:WEBI_VERSION\bin"
$pkg_src_dir = "$Env:USERPROFILE\.local\opt\cmake-v$Env:WEBI_VERSION"
$pkg_src = "$pkg_src_dir"
$pkg_src = "$pkg_src_cmd"
New-Item "$Env:USERPROFILE\Downloads\webi" -ItemType Directory -Force | Out-Null
$pkg_download = "$Env:USERPROFILE\Downloads\webi\$Env:WEBI_PKG_FILE"
# Fetch archive
IF (!(Test-Path -Path "$pkg_download")) {
IF (!(Test-Path -Path "$Env:USERPROFILE\Downloads\webi\$Env:WEBI_PKG_FILE")) {
Write-Output "Downloading cmake from $Env:WEBI_PKG_URL to $pkg_download"
& curl.exe -A "$Env:WEBI_UA" -fsSL "$Env:WEBI_PKG_URL" -o "$pkg_download.part"
& Move-Item "$pkg_download.part" "$pkg_download"
@@ -49,8 +49,6 @@ IF (!(Test-Path -Path "$pkg_src_dir")) {
Pop-Location
}
Write-Output "Copying into '$pkg_dst' from '$pkg_src'"
Remove-Item -Path "$pkg_dst" -Recurse -ErrorAction Ignore | Out-Null
Write-Output "Copying into '$pkg_dst_cmd' from '$pkg_src_cmd'"
Remove-Item -Path "$pkg_dst_cmd" -Recurse -ErrorAction Ignore | Out-Null
Copy-Item -Path "$pkg_src" -Destination "$pkg_dst" -Recurse
webi_path_add "$pkg_dst_bin"
& "$pkg_dst_cmd" --version

View File

@@ -6,35 +6,6 @@ var repo = 'CMake';
module.exports = function (request) {
return github(request, owner, repo).then(function (all) {
for (let rel of all.releases) {
{
let linuxRe = /(\b|_)(linux|gnu)(\b|_)/i;
let isLinux = linuxRe.test(rel.download) || linuxRe.test(rel.name);
if (isLinux) {
let muslRe = /(\b|_)(musl|alpine)(\b|_)/i;
let isMusl = muslRe.test(rel.download) || muslRe.test(rel.name);
if (isMusl) {
rel.libc = 'musl';
} else {
rel.libc = 'gnu';
}
continue;
}
}
{
let windowsRe = /(\b|_)(win\d*|windows\d*)(\b|_)/i;
let isWindows =
windowsRe.test(rel.download) || windowsRe.test(rel.name);
if (isWindows) {
rel.libc = 'msvc';
continue;
}
}
}
return all;
});
};

View File

@@ -1,47 +0,0 @@
---
title: feroxbuster
homepage: https://github.com/epi052/feroxbuster
tagline: |
feroxbuster: A tool designed to perform Forced Browsing.
---
To update or switch versions, run `webi feroxbuster@stable` (or `@v2`, `@beta`,
etc).
### Files
These are the files / directories that are created and/or modified with this
install:
```text
~/.config/feroxbuster/ferox-config.toml
~/.local/bin/feroxbuster
```
## Cheat Sheet
> `feroxbuster` is a tool designed for Forced Browsing. Forced browsing is an
> attack where the aim is to enumerate and access resources that are not
> referenced by the web application but are still accessible by an attacker.
To run feroxbuster:
```sh
feroxbuster -u [target]
```
### Include Headers
To run feroxbuster with custom headers:
```sh
feroxbuster -u [target] -H Accept:application/json "Authorization: Bearer {token}"
```
### Proxy Traffic Through Burp
To proxy traffic through Burp:
```sh
feroxbuster -u [target] --insecure --proxy http://127.0.0.1:8080
```

View File

@@ -1,55 +0,0 @@
#!/usr/bin/env pwsh
#######################
# Install feroxbuster #
#######################
# Every package should define these variables
$pkg_cmd_name = "feroxbuster"
$pkg_dst_cmd = "$Env:USERPROFILE\.local\bin\feroxbuster.exe"
$pkg_dst = "$pkg_dst_cmd"
$pkg_src_cmd = "$Env:USERPROFILE\.local\opt\feroxbuster-v$Env:WEBI_VERSION\bin\feroxbuster.exe"
$pkg_src_bin = "$Env:USERPROFILE\.local\opt\feroxbuster-v$Env:WEBI_VERSION\bin"
$pkg_src_dir = "$Env:USERPROFILE\.local\opt\feroxbuster-v$Env:WEBI_VERSION"
$pkg_src = "$pkg_src_cmd"
New-Item "$Env:USERPROFILE\Downloads\webi" -ItemType Directory -Force | Out-Null
$pkg_download = "$Env:USERPROFILE\Downloads\webi\$Env:WEBI_PKG_FILE"
# Fetch archive
IF (!(Test-Path -Path "$pkg_download")) {
Write-Host "Downloading feroxbuster from $Env:WEBI_PKG_URL to $pkg_download"
& curl.exe -A "$Env:WEBI_UA" -fsSL "$Env:WEBI_PKG_URL" -o "$pkg_download.part"
& move "$pkg_download.part" "$pkg_download"
}
IF (!(Test-Path -Path "$pkg_src_cmd")) {
Write-Verbose "Installing feroxbuster"
# TODO: create package-specific temp directory
# Enter tmp
pushd .local\tmp
# Remove any leftover tmp cruft
Remove-Item -Path ".\feroxbuster-v*" -Recurse -ErrorAction Ignore
Remove-Item -Path ".\feroxbuster.exe" -Recurse -ErrorAction Ignore
# Unpack archive file into this temporary directory
# Windows BSD-tar handles zip. Imagine that.
Write-Verbose "Unpacking $pkg_download"
& tar xf "$pkg_download"
# Settle unpacked archive into place
Write-Verbose "Install Location: $pkg_src_cmd"
New-Item "$pkg_src_bin" -ItemType Directory -Force | Out-Null
Move-Item -Path ".\feroxbuster-*\feroxbuster.exe" -Destination "$pkg_src_bin"
# Exit tmp
popd
}
Write-Host "Copying into '$pkg_dst_cmd' from '$pkg_src_cmd'"
Remove-Item -Path "$pkg_dst_cmd" -Recurse -ErrorAction Ignore | Out-Null
Copy-Item -Path "$pkg_src" -Destination "$pkg_dst" -Recurse

View File

@@ -1,46 +0,0 @@
#!/bin/sh
# shellcheck disable=SC2034
# "'pkg_cmd_name' appears unused. Verify it or export it."
__init_feroxbuster() {
set -e
set -u
##################
# Install feroxbuster #
##################
# Every package should define these 6 variables
pkg_cmd_name="feroxbuster"
pkg_dst_cmd="$HOME/.local/bin/feroxbuster"
pkg_dst="$pkg_dst_cmd"
pkg_src_cmd="$HOME/.local/opt/feroxbuster-v$WEBI_VERSION/bin/feroxbuster"
pkg_src_dir="$HOME/.local/opt/feroxbuster-v$WEBI_VERSION"
pkg_src="$pkg_src_cmd"
# pkg_install must be defined by every package
pkg_install() {
# ~/.local/opt/feroxbuster-v0.99.9/bin
mkdir -p "$(dirname "${pkg_src_cmd}")"
# mv ./feroxbuster-*/feroxbuster ~/.local/opt/feroxbuster-v0.99.9/bin/feroxbuster
mv ./feroxbuster "${pkg_src_cmd}"
}
# pkg_get_current_version is recommended, but not required
pkg_get_current_version() {
# 'feroxbuster --version' has output in this format:
# feroxbuster 0.99.9 (rev abcdef0123)
# This trims it down to just the version number:
# 0.99.9
feroxbuster --version 2> /dev/null |
head -n 1 |
cut -d ' ' -f 2
}
}
__init_feroxbuster

View File

@@ -50,10 +50,11 @@ __init_goreleaser() {
# This trims it down to just the version number:
# 1.21.2
# shellcheck disable=SC2046,SC2005 # unquoted echo trims whitespace
goreleaser --version 2> /dev/null |
grep 'GitVersion:' |
cut -d':' -f2 |
tr -d ' '
echo $(
goreleaser --version 2> /dev/null |
grep 'GitVersion:' |
cut -d':' -f2
)
}
}

View File

@@ -119,7 +119,6 @@ async function getAllReleases(request) {
let os = osMap[osPart];
let archPart = fileParts[1];
let arch = archMap[archPart];
let libc = '';
let pkgPart = fileParts[2];
let pkgs = pkgMap[pkgPart];
if (!pkgPart) {
@@ -134,16 +133,13 @@ async function getAllReleases(request) {
if (fileParts[2] === 'musl') {
extra = '-musl';
muslNative = true;
libc = 'musl';
} else if (os === 'linux') {
libc = 'gnu';
}
if (osPart === 'osx') {
osPart = 'darwin';
}
pkgs.forEach(function (pkg) {
if (osPart === 'osx') {
osPart = 'darwin';
}
let filename = `node-${build.version}-${osPart}-${archPart}${extra}.${pkg}`;
if ('msi' === pkg) {
filename = `node-${build.version}-${archPart}${extra}.${pkg}`;
@@ -160,7 +156,7 @@ async function getAllReleases(request) {
arch: arch,
ext: pkg,
download: downloadUrl,
libc: libc,
_musl_native: muslNative,
};
all.releases.push(release);

21
nvim/README.md Normal file
View File

@@ -0,0 +1,21 @@
---
title: nvim
homepage: https://neovim.io/
tagline: |
neovim: hyperextensible Vim-based text editor
---
To update or switch versions, run `webi nvim@stable` (or `@v0.7`, `@beta`, etc).
### Files
These are the files / directories that are created and/or modified with this
install:
```text
~/.config/envman/PATH.env
~/.config/nvim/init.vim
~/.local/opt/neovim/
```
## Cheat Sheet

57
nvim/install.sh Normal file
View File

@@ -0,0 +1,57 @@
#!/bin/sh
# shellcheck disable=SC2034
# "'pkg_cmd_name' appears unused. Verify it or export it."
__init_neovim() {
set -e
set -u
##################
# Install neovim #
##################
# Every package should define these 6 variables
pkg_cmd_name="nvim"
pkg_dst_cmd="$HOME/.local/opt/neovim/bin/nvim"
pkg_dst_dir="$HOME/.local/opt/neovim"
pkg_dst="$pkg_dst_dir"
pkg_src_cmd="$HOME/.local/opt/neovim-v$WEBI_VERSION/bin/nvim"
pkg_src_dir="$HOME/.local/opt/neovim-v$WEBI_VERSION"
pkg_src="$pkg_src_dir"
# pkg_install must be defined by every package
pkg_install() {
# mv ./nvim-* ~/.local/opt/neovim-macos
mv ./nvim-* "${pkg_src}"
}
# pkg_get_current_version is recommended, but not required
pkg_get_current_version() {
# 'nvim --version' has output in this format:
# NVIM v0.7.2
# Build type: Release
# LuaJIT 2.1.0-beta3
# Compiled by runner@Mac-1656256708179.local
#
# Features: +acl +iconv +tui
# See ":help feature-compile"
#
# system vimrc file: "$VIM/sysinit.vim"
# fall-back for $VIM: "/share/nvim"
#
# Run :checkhealth for more info
# This trims it down to just the version number:
# 0.7.2
nvim --version 2> /dev/null |
head -n 1 |
cut -d ' ' -f 2 |
sed 's/v//'
}
}
__init_neovim

View File

@@ -1,8 +1,8 @@
'use strict';
var github = require('../_common/github.js');
var owner = 'epi052';
var repo = 'feroxbuster';
var owner = 'neovim';
var repo = 'neovim';
module.exports = function (request) {
return github(request, owner, repo).then(function (all) {
@@ -13,8 +13,8 @@ module.exports = function (request) {
if (module === require.main) {
module.exports(require('@root/request')).then(function (all) {
all = require('../_webi/normalize.js')(all);
// just select the first 5 for demonstration
all.releases = all.releases.slice(0, 5);
all.releases = all.releases.slice(0, 10);
//console.info(JSON.stringify(all));
console.info(JSON.stringify(all, null, 2));
});
}

View File

@@ -7,6 +7,17 @@ tagline: |
To update or switch versions, run `webi pwsh@stable` (or `@v7.4`, `@beta`, etc).
### Files
These are the files / directories that are created and/or modified with this
install:
```text
~/.config/envman/PATH.env
~/.local/opt/pwsh/
~/.local/share/powershell/Modules
```
## Cheat Sheet
> The core benefit of running `pwsh` on Mac or Linux is that you get a way to
@@ -16,25 +27,6 @@ For example, if you want to create a `curl.exe -A "windows" | powershell` script
for Windows (as we do), it's helpful to be able to do some level of debugging on
other platforms.
## Table of Contents
- Files
- vim
- lint
- fmt
### Files
These are the files / directories that are created and/or modified with this
install:
```text
~/.config/envman/PATH.env
~/.local/opt/pwsh/
~/.local/share/powershell/Modules/
~/.local/opt/pwsh/Modules/
```
### How to Use PowerShell with Vim
Assuming you have [vim-ale](../vim-ale/) installed - which is included with
@@ -43,10 +35,6 @@ Assuming you have [vim-ale](../vim-ale/) installed - which is included with
See the "Lint & Fmt" section below.
### How to Use PowerShell with VSCode
_VS Code_ should also automatically recognize and use `PSScriptAnalyzer`.
### How to Lint & Fmt ps1 Files
You must install `PSScriptAnalyzer`. Then you can use `Invoke-ScriptAnalyzer`

View File

@@ -1,25 +0,0 @@
---
title: PSScriptAnalyzer
homepage: https://github.com/PowerShell/PSScriptAnalyzer
tagline: |
PSScriptAnalyzer is Formatter & Linter for PowerShell.
---
To update or switch versions, run `webi psscriptanalyzer`.
## Cheat Sheet
### Files
These are the files / directories that are created and/or modified with this
install:
```text
~/.local/share/powershell/Modules/
```
## Check the Installed Version
```pwsh
Get-Module -ListAvailable
```

View File

@@ -1,15 +0,0 @@
#!/bin/sh
set -e
set -x
__install_psscriptanalyzer() {
echo "Checking for pwsh (PowerShell Core)..."
if ! command -v pwsh > /dev/null; then
"$HOME/.local/bin/webi" pwsh
export PATH="$HOME/.local/opt/pwsh:$PATH"
fi
pwsh -Command "Install-Module -Name PSScriptAnalyzer -Scope CurrentUser -AllowClobber"
}
__install_psscriptanalyzer

View File

@@ -1,94 +0,0 @@
---
title: TinyGo
homepage: https://tinygo.org
tagline: |
TinyGo: The Power of Go, in Kilobytes.
---
To update or switch versions, run `webi tinygo@stable` (or `@v0.30`, `@beta`,
etc).
## Cheat Sheet
> TinyGo is an alternate, llvm-based compiler for Go with a much smaller and
> simpler runtime with a minimum size of _kilobytes_ - suitable for
> micro-controllers, embedded devices, and good old fashioned CLI utilities that
> don't need a high-performance garbage collector.
```sh
GOOS=linux GOARCH=arm64 \
tinygo build -short -no-debug \
-o hello-v1.0.0-linux-arm64
```
You may also want to install the Go IDE tooling:
[go-essentials](/go-essentials).
## Table of Contents
- Files
- Effective TinyGo
- Compatibility
- Gotchas
### Files
These are the files / directories that are created and/or modified with this
install:
```text
~/.config/envman/PATH.env
~/.local/opt/tinygo/
~/.local/opt/go/
~/go/
```
### Effective TinyGo
Core differences from Go's self-hosted compiler:
- optimizes for stack usage over heap usage
- avoids reflection
- simpler (but slower) garbage collection
- reimplements some of Go's standard library for performance
By following certain patterns, you can avoid forcing heap allocation and get
better memory usage and performance.
See:
- TinyGo: Heap Allocation:
<https://tinygo.org/docs/concepts/compiler-internals/heap-allocation/>.
- TinyGo: A New Compiler:
<https://tinygo.org/docs/concepts/faq/why-a-new-compiler/>
### Go Compatibility
Your _Go_, _TinyGo_, and dependency versions (particularly `golang.org/x`) will
need to be paired.
See the [Go Compatibility Matrix][go-compat]
[go-compat]: https://tinygo.org/docs/reference/go-compat-matrix/
### Gotchas
**Standard Library**
- avoid packages that rely heavily on reflection, like `encoding/json`
**Windows**:
- not all Windows syscalls are implemented
**macOS**:
- you may need to install a conflict-free version of `llvm` from
[conflict-free brew](../brew/) to get small sizes when cross-compiling
See also:
- TinyGo: Language Support: <https://tinygo.org/docs/reference/lang-support/>
- TinyGo: Gotchas: <https://tinygo.org/docs/guides/tips-n-tricks/>
- TinyGo: Differences from Go:
<https://tinygo.org/docs/concepts/compiler-internals/differences-from-go/>

View File

@@ -1,67 +0,0 @@
#!/usr/bin/env pwsh
#################
# Install tinygo #
#################
# Every package should define these variables
$pkg_cmd_name = "tinygo"
$pkg_dst_cmd = "$HOME\.local\opt\tinygo\bin\tinygo.exe"
$pkg_dst_dir = "$HOME\.local\opt\tinygo"
$pkg_dst = "$pkg_dst_dir"
$pkg_src_cmd = "$HOME\.local\opt\tinygo-v$Env:WEBI_VERSION\bin\tinygo.exe"
$pkg_src_bin = "$HOME\.local\opt\tinygo-v$Env:WEBI_VERSION\bin"
$pkg_src_dir = "$HOME\.local\opt\tinygo-v$Env:WEBI_VERSION"
$pkg_src = "$pkg_src_dir"
New-Item "$HOME\Downloads\webi" -ItemType Directory -Force | Out-Null
$pkg_download = "$HOME\Downloads\webi\$Env:WEBI_PKG_PATHNAME"
# Fetch archive
IF (!(Test-Path -Path "$pkg_download")) {
Write-Output "Downloading tinygo from $Env:WEBI_PKG_URL to $pkg_download"
& curl.exe -A "$Env:WEBI_UA" -fsSL "$Env:WEBI_PKG_URL" -o "$pkg_download.part"
& Move-Item "$pkg_download.part" "$pkg_download"
}
# Fetch Go compiler
Write-Output "Checking for Go compiler..."
IF (-Not (Get-Command -Name "go" -ErrorAction Silent)) {
& "$Env:USERPROFILE\.local\bin\webi-pwsh.ps1" go
$Env:Path = "$HOME\.local\opt\go\bin;$Env:Path"
$Env:Path = "$HOME\go\bin;$Env:Path"
[System.Environment]::SetEnvironmentVariable(
"Path",
$env:Path,
[System.EnvironmentVariableTarget]::User)
}
IF (!(Test-Path -Path "$pkg_src")) {
Write-Output "Installing tinygo"
# TODO: create package-specific temp directory
# Enter tmp
Push-Location .local\tmp
# Remove any leftover tmp cruft
Remove-Item -Path ".\tinygo*" -Recurse -ErrorAction Ignore
# Unpack archive file into this temporary directory
# Windows BSD-tar handles zip. Imagine that.
Write-Output "Unpacking $pkg_download"
& tar xf "$pkg_download"
# Settle unpacked archive into place
Write-Output "Install Location: $pkg_src"
Move-Item -Path ".\tinygo*" -Destination "$pkg_src_dir"
# Exit tmp
Pop-Location
}
Write-Output "Copying into '$pkg_dst' from '$pkg_src'"
Remove-Item -Path "$pkg_dst" -Recurse -ErrorAction Ignore | Out-Null
# no New-Item because $HOME\.local\opt" always exists
Copy-Item -Path "$pkg_src" -Destination "$pkg_dst" -Recurse

View File

@@ -1,53 +0,0 @@
#!/bin/sh
# shellcheck disable=SC2034
# "'pkg_cmd_name' appears unused. Verify it or export it."
__init_tinygo() {
set -e
set -u
##################
# Install tinygo #
##################
# Every package should define these 6 variables
pkg_cmd_name="tinygo"
pkg_dst_cmd="$HOME/.local/opt/tinygo/bin/tinygo"
pkg_dst_dir="$HOME/.local/opt/tinygo"
pkg_dst="$pkg_dst_dir"
pkg_src_cmd="$HOME/.local/opt/tinygo-v$WEBI_VERSION/bin/tinygo"
pkg_src_dir="$HOME/.local/opt/tinygo-v$WEBI_VERSION"
pkg_src="$pkg_src_dir"
# pkg_install must be defined by every package
pkg_install() {
echo "Checking for Go compiler..."
if ! command -v go 2> /dev/null; then
"$HOME/.local/bin/webi" go
export PATH="$HOME/.local/opt/go/bin:$PATH"
fi
# ~/.local/opt/tinygo-v0.30.0/
mkdir -p "$(dirname "${pkg_src_dir}")"
# mv ./tinygo*/ ~/.local/opt/tinygo-v0.30.0/
mv ./tinygo*/ "${pkg_src_dir}"
}
# pkg_get_current_version is recommended, but not required
pkg_get_current_version() {
# 'tinygo --version' has output in this format:
# tinygo version 0.30.0 darwin/amd64 (using go version go1.21.1 and LLVM version 16.0.1)
# This trims it down to just the version number:
# 0.30.0
tinygo version 2> /dev/null |
head -n 1 |
cut -d' ' -f3
}
}
__init_tinygo

View File

@@ -1,23 +0,0 @@
'use strict';
var github = require('../_common/github.js');
var owner = 'tinygo-org';
var repo = 'tinygo';
module.exports = function (request) {
return github(request, owner, repo).then(function (all) {
// all.releases = all.releases.filter(function (rel) {
// return !rel.name.endsWith('.deb');
// });
return all;
});
};
if (module === require.main) {
module.exports(require('@root/request')).then(function (all) {
all = require('../_webi/normalize.js')(all);
// just select the first 5 for demonstration
all.releases = all.releases.slice(0, 5);
console.info(JSON.stringify(all, null, 2));
});
}

View File

@@ -1,294 +0,0 @@
#!/bin/sh
set -e
set -u
#set -x
__webi_main() {
my_date="$(date +%F_%H-%M-%S)"
export WEBI_TIMESTAMP="${my_date}"
export _webi_tmp="${_webi_tmp:-$(
mktemp -d -t "webi-$WEBI_TIMESTAMP.XXXXXXXX"
)}"
if [ -n "${_WEBI_PARENT:-}" ]; then
export _WEBI_CHILD=true
else
export _WEBI_CHILD=
fi
export _WEBI_PARENT=true
my_os="$(uname -s)"
my_arch="$(uname -m)"
##
## Detect acceptable package formats
##
my_ext=""
set +e
# NOTE: the order here is least favorable to most favorable
if [ -n "$(command -v pkgutil)" ]; then
my_ext="pkg,$my_ext"
fi
# disable this check for the sake of building the macOS installer on Linux
#if [ -n "$(command -v diskutil)" ]; then
# note: could also detect via hdiutil
my_ext="dmg,$my_ext"
#fi
if [ -n "$(command -v git)" ]; then
my_ext="git,$my_ext"
fi
if [ -n "$(command -v unxz)" ]; then
my_ext="xz,$my_ext"
fi
if [ -n "$(command -v unzip)" ]; then
my_ext="zip,$my_ext"
fi
# for mac/linux 'exe' refers to the uncompressed binary without extension
my_ext="exe,$my_ext"
if [ -n "$(command -v tar)" ]; then
my_ext="tar,$my_ext"
fi
my_ext="$(echo "$my_ext" | sed 's/,$//')" # nix trailing comma
set -e
##
## Detect http client
##
set +e
WEBI_CURL="$(command -v curl)"
export WEBI_URL
WEBI_WGET="$(command -v wget)"
export WEBI_WGET
set -e
my_libc=''
if ldd /bin/ls 2> /dev/null | grep -q 'musl' 2> /dev/null; then
my_libc='musl'
elif uname -o | grep -q 'GNU' || uname -s | grep -q 'Linux'; then
my_libc='gnu'
else
my_libc='libc'
fi
export WEBI_HOST="${WEBI_HOST:-https://webinstall.dev}"
# ex: Darwin or Linux
my_sys="$(uname -s)"
# ex: 22.6.0
my_rev="$(uname -r)"
# ex: arm64
my_machine="$(uname -m)"
export WEBI_UA="${my_sys}/${my_rev} ${my_machine}/unknown ${my_libc}"
webinstall() {
my_package="${1:-}"
if [ -z "$my_package" ]; then
echo >&2 "Usage: webi <package>@<version> ..."
echo >&2 "Example: webi node@lts rg"
exit 1
fi
WEBI_BOOT="$(
mktemp -d -t "$my_package-bootstrap.$WEBI_TIMESTAMP.XXXXXXXX"
)"
export WEBI_BOOT
my_installer_url="$WEBI_HOST/api/installers/$my_package.sh?formats=$my_ext"
if [ -n "$WEBI_CURL" ]; then
if ! curl -fsSL "$my_installer_url" -H "User-Agent: curl $WEBI_UA" \
-o "$WEBI_BOOT/$my_package-bootstrap.sh"; then
echo >&2 "error fetching '$my_installer_url'"
exit 1
fi
else
if ! wget -q "$my_installer_url" --user-agent="wget $WEBI_UA" \
-O "$WEBI_BOOT/$my_package-bootstrap.sh"; then
echo >&2 "error fetching '$my_installer_url'"
exit 1
fi
fi
(
cd "$WEBI_BOOT"
sh "$my_package-bootstrap.sh"
)
rm -rf "$WEBI_BOOT"
}
show_path_updates() {
if test -z "${_WEBI_CHILD}"; then
if test -f "$_webi_tmp/.PATH.env"; then
my_paths=$(sort -u < "$_webi_tmp/.PATH.env")
if test -n "$my_paths"; then
printf 'PATH.env updated with:\n'
printf "%s\n" "$my_paths"
printf '\n'
printf "\e[1m\e[35mTO FINISH\e[0m: copy, paste & run the following command:\n"
printf "\n"
printf " \e[1m\e[32msource ~/.config/envman/PATH.env\e[0m\n"
printf " (newly opened terminal windows will update automatically)\n"
fi
rm -f "$_webi_tmp/.PATH.env"
fi
fi
}
fn_checksum() {
cmd_shasum='sha1sum'
if command -v shasum > /dev/null; then
cmd_shasum='shasum'
fi
$cmd_shasum "${0}" | cut -d' ' -f1 | cut -c 1-8
}
version() {
my_checksum="$(
fn_checksum
)"
my_version=v1.2.0
printf "\e[35mwebi\e[32m %s\e[0m Copyright 2020+ AJ ONeal\n" "${my_version} (${my_checksum})"
printf " \e[36mhttps://webinstall.dev/webi\e[0m\n"
}
# show help if no params given or help flags are used
usage() {
echo ""
version
echo ""
printf "\e[1mSUMMARY\e[0m\n"
echo " Webi is the best way to install the modern developer tools you love."
echo " It's fast, easy-to-remember, and conflict free."
echo ""
printf "\e[1mUSAGE\e[0m\n"
echo " webi <thing1>[@version] [thing2] ..."
echo ""
printf "\e[1mUNINSTALL\e[0m\n"
echo " Almost everything that is installed with webi is scoped to"
echo " ~/.local/opt/<thing1>, so you can remove it like so:"
echo ""
echo " rm -rf ~/.local/opt/<thing1>"
echo " rm -f ~/.local/bin/<thing1>"
echo ""
echo " Some packages have special uninstall instructions, check"
echo " https://webinstall.dev/<thing1> to be sure."
echo ""
printf "\e[1mOPTIONS\e[0m\n"
echo " Generic Program Information"
echo " --help Output a usage message and exit."
echo ""
echo " -V, --version"
echo " Output the version number of webi and exit."
echo ""
echo " Helper Utilities"
echo " --list Show everything webi has to offer."
echo ""
echo " --info <package>"
echo " Show various links and example release."
echo ""
printf "\e[1mFAQ\e[0m\n"
printf " See \e[34mhttps://webinstall.dev/faq\e[0m\n"
echo ""
printf "\e[1mALWAYS REMEMBER\e[0m\n"
echo " Friends don't let friends use brew for simple, modern tools that don't need it."
echo " (and certainly not apt either **shudder**)"
echo ""
}
if [ $# -eq 0 ] || echo "$1" | grep -q -E '^(-V|--version|version)$'; then
version
exit 0
fi
if echo "$1" | grep -q -E '^(-h|--help|help)$'; then
usage "$@"
exit 0
fi
if echo "$1" | grep -q -E '^(-l|--list|list)$'; then
echo >&2 "[warn] the format of --list output may change"
# because we don't have sitemap.xml for dev sites yet
my_host="https://webinstall.dev"
my_len="${#my_host}"
# 6 because the field will looks like "loc>WEBI_HOST/PKG_NAME"
# and the count is 1-indexed
my_count="$((my_len + 6))"
curl -fsS "${my_host}/sitemap.xml" |
grep -F "${my_host}" |
cut -d'<' -f2 |
cut -c "${my_count}"-
exit 0
fi
if echo "${1}" | grep -q -E '^(--info|info)$'; then
if test -z "${2}"; then
echo >&2 "Usage: webi --info <package>"
exit 1
fi
echo >&2 "[warn] the output of --info is completely half-baked and will change"
my_pkg="${2}"
# TODO need a way to check that it exists at all (readme, win, lin)
echo ""
echo " Cheat Sheet: ${WEBI_HOST}/${my_pkg}"
echo " POSIX: curl -sS ${WEBI_HOST}/${my_pkg} | sh"
echo " Windows: curl.exe -A MS ${WEBI_HOST}/${my_pkg} | powershell"
echo "Releases (JSON): ${WEBI_HOST}/api/releases/${my_pkg}.json"
echo " Releases (tsv): ${WEBI_HOST}/api/releases/${my_pkg}.tab"
echo " (query params): ?channel=stable&limit=10"
echo " &os=${my_os}&arch=${my_arch}"
echo " Install Script: ${WEBI_HOST}/api/installers/${my_pkg}.sh?formats=tar,zip,xz,git,dmg,pkg"
echo " Static Assets: ${WEBI_HOST}/packages/${my_pkg}/README.md"
echo ""
# TODO os=linux,macos,windows (limit to tagged releases)
my_releases="$(
curl -fsS "${WEBI_HOST}/api/releases/${my_pkg}.json?channel=stable&limit=1&pretty=true"
)"
if printf '%s\n' "${my_releases}" | grep -q "error"; then
my_releases_beta="$(
curl -fsS "${WEBI_HOST}/api/releases/${my_pkg}.json?&limit=1&pretty=true"
)"
if printf '%s\n' "${my_releases_beta}" | grep -q "error"; then
echo >&2 "'${my_pkg}' is a special case that does not have releases"
else
echo >&2 "ERROR no stable releases for '${my_pkg}'!"
fi
exit 0
fi
echo >&2 "Stable '${my_pkg}' releases:"
if command -v jq > /dev/null; then
printf '%s\n' "${my_releases}" |
jq
else
printf '%s\n' "${my_releases}"
fi
exit 0
fi
for pkgname in "$@"; do
webinstall "$pkgname"
done
show_path_updates
}
__webi_main "$@"